 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: Avancement.h,v 1.3 2001/03/18 22:22:09 daville Exp $
 * $Log: Avancement.h,v $
 * Revision 1.3  2001/03/18 22:22:09  daville
 * Ajout de lignes fin fichier.
 *
 * Revision 1.2  2000/11/02 21:41:40  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef AVANCEMENT_H
#define AVANCEMENT_H
#include <stdio.h>

enum XMState{
	XMST_VOID,  // Etat vide;
	XMST_BUSY,  // Occupe: soit XMATH crit soit VDK lit
	XMST_FREE,  // Libre;
	XMST_KILL}; // Arrt demande

	
class Avancement;
class HandleCore
{
public:
	HandleCore(){};
	virtual int ReachCore(Avancement *av)=0;
	virtual ~HandleCore(){};
};

class Avancement
{
		HandleCore *mHandleCore;
	protected:
		int mNStage;		// Nombre d'tape
		int mNStatement;	// Nombre d'instruction
		int mStage;		// Etape en cours
		int mStatement;		// Instruction en cours
		XMState mState;
		char *mStageName;	// Nom de l'tape en cours
	public:
		Avancement();
		Avancement(Avancement *av);
		HandleCore *&Handle();
		int ReachCore();
		int &NStage();
		int &NStatement();
		int &Stage();
		int &Statement();
		int &State();
		int IsVoid();
		int IsBusy();
		int IsFree();
		int SetVoid();
		int SetBusy();
		int SetFree();
		double Total();
		char *&StageName();
};

#endif   /* AVANCEMENT_H */
