 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.4 $
 *
 * $Id: Communication.cpp,v 1.4 2001/04/11 23:48:34 daville Exp $
 * $Log: Communication.cpp,v $
 * Revision 1.4  2001/04/11 23:48:34  daville
 * Modification d'une trace.
 *
 * Revision 1.3  2001/03/18 22:30:51  daville
 * Ajout de lignes fin fichier.
 *
 * Revision 1.2  2000/11/02 21:45:35  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <stdio.h>
#include <VGlobale.h>
#include <Communication.h>
#include <Assistant.h>


char *GetNameOfFluxCommunication(char RW, int id)
{
	char *AdresseRW=NULL;
	
	if (id != -1)
	{
		AdresseRW = new char[strlen(GetVGlobale(VG_CANAL_FLUX))+strlen("/XMCorePipe")+10+1+1];
		sprintf(AdresseRW, "%s/XMCorePipe%5.5d%c", GetVGlobale(VG_CANAL_FLUX), id, RW);
	}else
	{
		AdresseRW = new char[strlen(GetVGlobale(VG_CANAL_FLUX))+strlen("/XMCorePipe")+1+1];
		sprintf(AdresseRW, "%s/XMCorePipe%c", GetVGlobale(VG_CANAL_FLUX), RW);
	}
	return AdresseRW;
}

XMPipe *CreerFluxCommunication(int id, XMPipe *pipe)
{
	char AdresseW[strlen(GetVGlobale(VG_CANAL_FLUX))+strlen("/XMCorePipe")+10];
	char AdresseR[strlen(GetVGlobale(VG_CANAL_FLUX))+strlen("/XMCorePipe")+10];
	int RStatut, WStatut;
		
	if (id != -1)
	{
		sprintf(AdresseW, "%s/XMCorePipe%5.5dR", GetVGlobale(VG_CANAL_FLUX), id);
		sprintf(AdresseR, "%s/XMCorePipe%5.5dW", GetVGlobale(VG_CANAL_FLUX), id);
		
	}else
	{
		sprintf(AdresseW, "%s/XMCorePipeR", GetVGlobale(VG_CANAL_FLUX));
		sprintf(AdresseR, "%s/XMCorePipeW", GetVGlobale(VG_CANAL_FLUX));
	}
	if (mkfifo(AdresseW, S_IRUSR|S_IWUSR|S_IRGRP) == -1)
	{
		printf("Erreur de cration du canal de communication [%s]\n", AdresseW);
		exit(0);
	}
	if (mkfifo(AdresseR, S_IRUSR|S_IWUSR|S_IRGRP) == -1)
	{
		printf("Erreur de cration du canal de communication [%s]\n", AdresseR);
		exit(0);
	}
	if ((pipe->IDWrite = open(AdresseW, O_RDWR)) == -1)
	{
		printf("Erreur d'ouverture du canal de communication\n");
		delete pipe;
		return NULL;
	}
	if ((pipe->IDRead = open(AdresseR, O_RDWR)) == -1)
	{
		printf("Erreur d'ouverture du canal de communication\n");
		delete pipe;
		return NULL;
	}
	WStatut = fcntl(pipe->IDWrite, F_GETFL);
	fcntl(pipe->IDWrite, F_SETFL, WStatut | O_NONBLOCK);
	RStatut = fcntl(pipe->IDRead, F_GETFL);
	fcntl(pipe->IDRead, F_SETFL, RStatut | O_NONBLOCK);
	return (pipe);
}

SCConnection * ConnectClientToServer()
{
	return ConnectClient();
}

XMQuery *ReadQueryFromClient()
{
	static XMQuery Flux;
	XMPipe *Client;
	int k;
	
	for(k=0; Client=GetPipeConnection(k); k++)
		if (read(Client->IDRead, &Flux, sizeof(XMQuery)) != -1) return ((XMQuery *)(&Flux));
	if (k<=3) sleep(1); else if (k==4) for (int j=0; j<10000;j++); else if (k==5) for (int j=0; j<7000;j++);
	return NULL;
}

int	SendReponseToClient(XMPipe *pipe, XMReponse *pReponse)
{
	//printf("Envoye sur: [%d]\n", pipe->IDWrite);
	return (write(pipe->IDWrite, pReponse, sizeof(XMReponse)));
}

int	SendFileReponseToClient(XMPipe *pipe, CFile<XMReponse *> *fReponse)
{
	int NbPacketEnvoyes=0;
	XMReponse *pReponse;
	while (!fReponse->Vide())
	{
		fReponse->Defiler(pReponse);
		printf("ENVOI>> Stream %d  IDClient: %d  IDReponse: %d  Reponse: %s\n", pipe->IDWrite, pReponse->IDClient, pReponse->IDReponse, pReponse->Reponse);
		for (;SendReponseToClient(pipe, pReponse)==-1;) for(int k=0;k<150;k++);
		NbPacketEnvoyes++;
		delete pReponse;
	}
	delete fReponse;
	return NbPacketEnvoyes;
}

void DetruireFluxCommunation(XMPipe *&pipe, int id_user)
{
	char *W, *R;
	close(pipe->IDWrite);
	close(pipe->IDRead);
	
	W = GetNameOfFluxCommunication('W', id_user);
	R = GetNameOfFluxCommunication('R', id_user);
	//printf("CANAL: %s\n", W);
	unlink(W); unlink(R);
	delete W;  delete R;
	delete pipe;
	pipe = NULL;
}

int DisconnectClientToServer(int id_user)
{
	if (id_user > -1)	return (DisconnectClient(id_user, DetruireFluxCommunation)?1:0);
	if (id_user == -1)	return  DisconnectAllClient(DetruireFluxCommunation);
	return 0;
}

int   ReadQuery(XMQuery *query, int &id_client, int &id_query, char *data)
{
	id_client	= query->IDClient;
	id_query	= query->IDQuery;
	sprintf(data, "%s", query->Query);
	return id_query;
}

/*************************************************/
/*************************************************/
XMReponse *InitReponse(XMReponse *reponse)
{
	if (!reponse) return NULL;
	reponse->IDReponse = XMRUNKNOWN;
	reponse->Reponse[0]='\0';
	return reponse;
}
/*************************************************/
/*************************************************/

XMReponse * MakeReponse(XMReponse *reponse, int id_client, int id_reponse, void *data)
{
	reponse->IDClient	= id_client;
	reponse->IDReponse	= id_reponse;
	if (!data) return reponse;
	sprintf(reponse->Reponse, "%s", data);
	return reponse;
}
