 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: Communication.h,v 1.3 2001/03/18 22:32:33 daville Exp $
 * $Log: Communication.h,v $
 * Revision 1.3  2001/03/18 22:32:33  daville
 * Ajout de directive d'inclusion du fichier stdlib.h et ajAjout de lignes fin fichie
 *
 * Revision 1.2  2000/11/02 21:45:44  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <stdlib.h>
#include <ToolsXMProtocol.h>
#include <File.h>
#include <XMCore.h>

#ifndef COMMUNICATION_H
#define COMMUNICATION_H

#define  CANAL_DE_DONNEES	"/home/daville/Projects/XMaths/flux/XMCorePipe"
#define	 TEMPS_ATTENTE		250000

XMPipe  *CreerFluxCommunication(int id, XMPipe *acon);
XMQuery *LireRequete(XMPipe *pipe);

SCConnection * ConnectClientToServer();
int	  SendReponseToClient(XMPipe *pipe, XMReponse *pReponse);
int	  SendFileReponseToClient(XMPipe *pipe, CFile<XMReponse *> *fReponse);
XMQuery   *ReadQueryFromClient();
int	  DisconnectClientToServer(int id_user);
int	  ReadQuery(XMQuery *query, int &id_client, int &id_query, char *query);
XMReponse *InitReponse(XMReponse *reponse);
XMReponse *MakeReponse(XMReponse *reponse, int id_client, int id_query, char *reponse);

#endif  /* XMCORE_H */
