 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: File.h,v 1.3 2001/03/18 22:34:35 daville Exp $
 * $Log: File.h,v $
 * Revision 1.3  2001/03/18 22:34:35  daville
 * Ajout de lignes fin fichier.
 *
 * Revision 1.2  2000/11/02 21:47:50  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef CFILE_H
#define CFILE_H

typedef struct SFile
{
        void *PInfo;
        struct SFile *Suiv;
}SFile;

template <class T> class CFile
{
        protected:
        	SFile *mCourant,*mTete, *Ptr[2], *mCourantNP, *mTeteNP;
        public:
        	CFile(){ mCourant=NULL;mTete=NULL;};
        	CFile(CFile &file);
        	void Take(T &info);
        	void Enfiler(T info);
        	void Defiler(T &info);
        	void GetTete(T &Info);
        	void AllerTete(T &Info);
        	int  Occurrence();
        	int  Vide(){return (mCourant==NULL);};
        	CFile <T> &operator= (CFile <T>&file);
        	int  VideNP(){return (mCourantNP==NULL);};
        	int GetCount();
        	void InitNP();
        	void DefilerNP(T *&info);
        	~CFile();
};

template <class T> CFile<T>::CFile(CFile &file)
{
        SFile *Ptr=file.mTete,*P,*M=NULL;
        T *PtrT;
        mCourant=NULL;
        while (Ptr)
        {
                P=new SFile;
                PtrT=(T *)new T;
                *PtrT=*((T *)(Ptr->PInfo));
                P->PInfo=(void *)(PtrT);
                P->Suiv=NULL;
                if (M) M->Suiv=P; else mTete=P;
                Ptr=Ptr->Suiv;
                M=P;
        }
        mCourantNP=mCourant=P;
}


template <class T> void CFile<T>::Enfiler(T info)
{
       SFile *P;
       T *ptr=new T;
       P=mCourant;
       mCourant=new SFile;
       mCourant->Suiv=NULL;
       if (P) P->Suiv=mCourant;else mTete=mCourant;
       *ptr=info;
       mCourant->PInfo=(void *)ptr;
}

template <class T> void CFile<T>::Defiler(T &info)
{
        if (mTete)
        {
                SFile *P;
                info=*((T*)(mTete->PInfo));
                P=mTete;  mTete=mTete->Suiv;
        	delete ((T *)(P->PInfo)); delete ((SFile *)(P));
        	if (!mTete) mCourant=NULL;
        }
        
}

template <class T> void CFile<T>::Take(T &info)
{
        if (mTete)
        {
                SFile *P;
                info=*((T*)(mTete->PInfo));
                P=mTete;  Ptr[0]=mTete=mTete->Suiv;
        	delete ((T *)(P->PInfo)); delete ((SFile *)(P));
        	if (!mTete) Ptr[1]=mCourant=NULL;
        }
}
 

template <class T> void CFile<T>::AllerTete(T &Info)
{
        mTete = Ptr[0];
        mCourant = Ptr[1];
        if (mTete) Info=*((T*)(mTete->PInfo));
}
  
template <class T> void CFile<T>::GetTete(T &Info)
{
        if (mTete) Info=*((T*)(mTete->PInfo));
} 

template <class T> int CFile<T>::Occurrence()
{
        int Nbre=0;
        SFile *P = mTete;
        while (P)
        {
                P = P->Suiv;
                Nbre++;
        }
        return Nbre;                        
}

template <class T> CFile <T> &CFile<T>::operator= (CFile <T> &file)
{
        CFile F(file);
        return F;
}

template <class T> void CFile<T>::InitNP()
{
	mCourantNP = mTeteNP = mTete;
}

template <class T> int CFile<T>::GetCount()
{
	SFile *Ptr;
	int n=0;
	for (Ptr = mTete; Ptr; n++) Ptr = Ptr->Suiv;
	return n;
}

template <class T> void CFile<T>::DefilerNP(T *&info)
{
        if (mCourantNP)
        {
                info=(T*)(mCourantNP->PInfo);
                mCourantNP=mCourantNP->Suiv;
        }
        
}

template <class T> CFile<T>::~CFile()
{
        SFile *P;
        mCourant=mTete;
        while (mCourant)
        {
                P=mCourant;
                mCourant=mCourant->Suiv;
        	delete ((T *)(P->PInfo)); delete ((SFile *)(P));
        }
}

#endif
