 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: IXMObjectX.h,v 1.3 2001/03/18 22:35:02 daville Exp $
 * $Log: IXMObjectX.h,v $
 * Revision 1.3  2001/03/18 22:35:02  daville
 * Ajout de lignes fin fichier.
 *
 * Revision 1.2  2000/11/02 22:10:22  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef IXMOBJECTX_H
#define IXMOBJECTX_H
#include "head.h"
#include "Liste.h"
#include "intervalle.h"
#include "math.h"
#include "vecteur.h"
#include "variable.h"
#include "matrice.h"
#include "whole.h"
#include "plot.h"

/////////////////////////////////////////////////////////////////////////////////////////////
// Fonction permettant de crer une variable						   //
/////////////////////////////////////////////////////////////////////////////////////////////
XMVariable* MakeVariable(char *vals, char *nom, char **var, TYPE *pt);			   //
/////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////
// Fonction permettant de crer une fonction						   //
/////////////////////////////////////////////////////////////////////////////////////////////
XMFonction* MakeFonction(char *exp, char *nom, char **Var, TYPE *val=NULL);		   //
/////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////
// Fonction permettant de crer une matrice						   //
/////////////////////////////////////////////////////////////////////////////////////////////
XMMatrice* MakeMatrice(XMWhole *vect, char *nom, char **Var, TYPE *val=NULL);		   //
/////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////
// Fonction permettant de crer un vecteur						   //
/////////////////////////////////////////////////////////////////////////////////////////////
XMVecteur* MakeVecteur(CList<XMObjectX *> *lvar, char *nom, char **var, TYPE *val=NULL);		   //
/////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////
// Fonction permettant de crer un plot						   //
/////////////////////////////////////////////////////////////////////////////////////////////
XMPlot* MakePlot(XMWhole *whole, char *nom, char **var, TYPE *val=NULL);		   //
/////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////
// Fonction permettant de crer un intervalle						   //
/////////////////////////////////////////////////////////////////////////////////////////////
XMIntervalle* MakeIntervalle(CList<XMObjectX *> *lvar, char *nom, char **var, TYPE *val=NULL);//
/////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////
// Fonction permettant de crer un ensemble						   //
/////////////////////////////////////////////////////////////////////////////////////////////
XMWhole* MakeWhole(CList<XMObjectX *> *lob, char *nom, char **var, TYPE *val=NULL);	   //
/////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////
// Fonction permettant de crer un head							   //
/////////////////////////////////////////////////////////////////////////////////////////////
XMHead* MakeHead(CList<XMObjectX *> *lob, char *nom, char **var, TYPE *val=NULL);	   //
/////////////////////////////////////////////////////////////////////////////////////////////

#endif /*IXMOBJECTX_H*/




