 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.6 $
 *
 * $Id: XMCore.cpp,v 1.6 2001/04/14 14:06:08 daville Exp $
 * $Log: XMCore.cpp,v $
 * Revision 1.6  2001/04/14 14:06:08  daville
 * Modification de l'ordre d'appel des fonctionsd'initialisations
 *
 * Revision 1.5  2001/04/07 11:05:24  daville
 * On n'utilise plus de fichier input mais une variable d'environnement pour aller chercher les fichier de configuration.
 * Modification du passage de parametre  l'appel de l a fonction SetVGlobale
 *
 * Revision 1.4  2001/04/03 23:43:02  daville
 * Ajout du cast (XMSender *) pour l'appel  l'oprateur delete.
 *
 * Revision 1.3  2000/11/05 13:40:41  daville
 * Modification suite au nla fonction SetVGlobalNouveau prototypage de
 *
 * Revision 1.2  2000/11/02 22:09:34  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <stdlib.h>
#include <stdio.h>
#include <XMCore.h>
#include <pthread.h>
#include <Communication.h>
#include <Assistant.h>
#include <ToolsXMProtocol.h>
#include <VGlobale.h>
#define  NOM_FICHIER_INPUT	"ESM_FILENAME_INPUT"

/*****************************************************************/
/*****************************************************************/
/**			Fonction principale			**/
/*****************************************************************/
/*****************************************************************/

static int gStopServer=0;
int ChargerParametreDeConfiguration();
void CleanFlux();

int main(int argc, char *argv)
{
	XMQuery *pQuery;
	FILE *pFile;
	
	
	atexit(CleanFlux);
	printf("Initialising server ....\n");
	if (!ChargerParametreDeConfiguration()) exit(0);
	CleanFlux();
	printf("Server XMCore started .........\n");
	CreerFluxCommunication(-1, GetPipeClient(ConnectClientToServer()->mID));
	while (!gStopServer)
	{
		if (pQuery = ReadQueryFromClient())
			 Dispatche(pQuery);
	}
	DisconnectClientToServer(-1);
	return 0;
}
/****************************************************************/
/****************************************************************/

int Dispatche(XMQuery *pQuery)
{
	pthread_t thread;
	pthread_attr_t pthread_attr;
	XMSender *sender;
	int k;
	
	sender = new XMSender;
	sender->Set(NULL, pQuery, k);
	pthread_attr_init(&pthread_attr);
	pthread_create (&thread, &pthread_attr, TraiterRequete, sender);
	return thread;
}

void *TraiterRequete(void *sender)
{
	if (!sender) return NULL;
	CFile<XMReponse *> *fReponse=NULL;
	
	XMReponse *pReponse = NULL;
	
	XMQuery *query	= ((XMSender * )sender)->mQuery;
	XMPipe  *pipe	= GetPipeClient(query->IDClient);
	
	switch (query->IDQuery)
	{
		case CQUNKNOWN:
			{
				fReponse=new CFile<XMReponse *>;
				pReponse = InitReponse(new XMReponse);
				printf("[%d] Message inconnu [%d]\n", query->IDClient, CQUNKNOWN);
				pReponse->IDClient = query->IDClient;
				fReponse->Enfiler(pReponse);
			}break;
		case CQCONNECTION:
			{
				SCConnection *acon;
				fReponse=new CFile<XMReponse *>;
				pReponse = InitReponse(new XMReponse);
        			acon = ConnectClientToServer();
        			printf("[%d] Message demande connexion [%d]\n", acon->mID, CQCONNECTION);
				pReponse->IDClient = acon->mID;
				pReponse->IDReponse = XMRCONNECTION;
				CreerFluxCommunication(acon->mID, GetPipeClient(acon->mID));
				fReponse->Enfiler(pReponse);
			}break;
		case CQDECONNECTION:
			{
				SCConnection *acon;
				fReponse=new CFile<XMReponse *>;
				pReponse = InitReponse(new XMReponse);
				DisconnectClientToServer(query->IDClient);
        			pReponse->IDClient = query->IDClient;
				pReponse->IDReponse = XMRDECONNECTION;
				gStopServer = 1;
				fReponse->Enfiler(pReponse);
			}break;
		case CQSHUTDOWN:
			{
				fReponse=new CFile<XMReponse *>;
				pReponse = InitReponse(new XMReponse);
        			pReponse->IDClient = query->IDClient;
				pReponse->IDReponse = XMRSHUTDOWN;
				gStopServer = 1;
				fReponse->Enfiler(pReponse);				
			}break;
		case CQSCRIPT:
			{
				char *aQuery;
        			printf("[%d] Message requete maths\n", query->IDClient);
				fReponse = (CFile<XMReponse *> *)SendToAssistant(query->IDClient, GetField(query->Query, 1, 1));
			}break;
		case CQFCN_TOTO:
			break;
		default:
			break;
	}
	delete ((XMSender * )sender);
	printf("SERVER>> %d\n", SendFileReponseToClient(pipe, fReponse));
	return NULL;
}

int ChargerParametreDeConfiguration()
{
	FILE *pFile;
	char *Parametre;
	
	/* Rcupration du chemin du fichier dans la variable	*/
	/* d'environnement.				*/
	if ((Parametre = getenv(NOM_FICHIER_INPUT)) == NULL) return 0;
	
	/* Ouverture du fichier de parametrage		*/
	if (!(pFile = OuvrirFichierConf(Parametre))) return 0;
	if (!(Parametre = LireParametreFichierConf(pFile, "FLUX", "FLUX_DIR"))) return 0;
	SetVGlobale(VG_CANAL_FLUX, Parametre);
	return 1;
}

void CleanFlux()
{
	char com[1000];
	if (!GetVGlobale(VG_CANAL_FLUX)) return;
	sprintf(com, "rm -f %s/XMCorePipe*>/dev/null", GetVGlobale(VG_CANAL_FLUX));
	system(com);
}

class XMObjectX * GetObjectX(char *){ return NULL;}
