 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: XMMath.cpp,v 1.2 2001/04/03 23:25:27 daville Exp $
 * $Log: XMMath.cpp,v $
 * Revision 1.2  2001/04/03 23:25:27  daville
 * Dfinition de nouvelles fonctions.
 *
 * Revision 1.1  2001/03/24 11:28:58  daville
 * Initial revision
 *
 *
 ***********************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <math.h> 
//#include <XMMath.h>


/* Define the ch fonction */
double  XMCh(double val)
{
	return (double)(exp(val) + exp(-val))/2;
}

/* Define the sh function */
double  XMSh(double val)
{
	return (double)(exp(val) - exp(-val))/2;
}

/* Signature of th function */
double  XMTh(double val)
{
	return (double)((1 - exp(2*val)) / (1 + exp(2*val)));
}

/* Define the ch fonction */
double  XMACh(double val)
{
	return (double)(log(val + sqrt(val*val - 1)));
}

/* Define the sh function */
double  XMASh(double val)
{
	return (double)(log(val + sqrt(val*val + 1)));
}

/* Signature of th function */
double  XMATh(double val)
{
	return (double)(log(1 + val) / log(1 - log(val))) / 2;
}


