 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.2 $
 *
 * $Id: XMMath.h,v 1.2 2001/04/03 23:24:30 daville Exp $
 * $Log: XMMath.h,v $
 * Revision 1.2  2001/04/03 23:24:30  daville
 * Ajout de nouvelles fonctions (Fichier temporaire).
 *
 * Revision 1.1  2001/03/24 11:28:45  daville
 * Initial revision
 *
 *
 ***********************************************************************/

#ifndef XMMATH_H
#define XMMATH_H
#include <math.h>

#define XMSqrt		sqrt
//#define XMExp		exp
#define XMLn		log
#define XMCos		cos
#define XMSin		sin
#define XMTan		tan
#define XMAbs		abs
#define XMPow		pow
#define XMACos		acos
#define XMASin		asin
#define XMATan		atan

double XMSqrt(double );
double XMATan(double );

/* Signature of ch fonction */
double  XMCh(double val);

/* Signature of sh function */
double  XMSh(double val);

/* Signature of th function */
double  XMTh(double val);

/* Signature of ch fonction */
double  XMACh(double val);

/* Signature of sh function */
double  XMASh(double val);

/* Signature of th function */
double  XMATh(double val);

#endif

