 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: XMThread.cpp,v 1.3 2001/04/03 23:21:59 daville Exp $
 * $Log: XMThread.cpp,v $
 * Revision 1.3  2001/04/03 23:21:59  daville
 * Modification suite aux modificationx sur le compilateur c++ pour le passage en paramtre de pointeur de fonctionq
 *
 * Revision 1.2  2000/11/02 22:09:13  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <XMThread.h>


XMThread::XMThread()
{
	mIDGThread = 0;
}

GPointer XMThread::Parameter()
{
	return mParameter;
}
	
GPointer XMThread::Start(GThreadFunction init=NULL, GPointer Parameter=NULL)
{
	GThreadAttr attr;
	mParameter = Parameter;
	mIDGThread = (init?GThreadCreate(init,NULL,GThreadAttrInit(&attr)):GThreadCreate(gGTFunction, this, GThreadAttrInit(&attr)));
	return mIDGThread;
}

void XMThread::Join()
{
	int status;
	GThreadJoin(mIDGThread, (void *)status);
}

void XMThread::Exit()
{

}

void XMThread::Wait(int time=0)
{
	GThreadWait(time);
}

void gGTFunction(void *Parameter)
{
	if (Parameter == NULL) return;
	((XMThread *)Parameter)->Execute(((XMThread *)Parameter)->Parameter());
	return;
}
