 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: XMValueX.h,v 1.3 2001/04/03 23:22:13 daville Exp $
 * $Log: XMValueX.h,v $
 * Revision 1.3  2001/04/03 23:22:13  daville
 * Ajout de lignes fin de fichier.
 *
 * Revision 1.2  2000/11/02 22:07:43  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <stdio.h>
#include <type.h>

class XMValueX;

bool TABComparateurExecStrictementInferieur(XMValueX *val1, XMValueX *val2);
bool TABComparateurExecStrictementSuperieur(XMValueX *val1, XMValueX *val2);
bool TABComparateurExecInferieurOuEgal(XMValueX *val1, XMValueX *val2);
bool TABComparateurExecSuperieurOuEgal(XMValueX *val1, XMValueX *val2);
bool TABComparateurExecEgal(XMValueX *val1, XMValueX *val2);

class XMValueX
{
	TValueX mType;
	int mSignificatif;
	void *mValue;
protected:
	bool InitialiserValue(TValueX type, void *val);
public:
	XMValueX();
	XMValueX(TValueX type, int significatif = XM_DEFAULT_SIGNIFICATIF);
	XMValueX operator= (XMValueX valx);
	XMValueX operator= (long val);
	XMValueX operator= (long long val);
	XMValueX operator= (int val);
//	XMValueX operator= (long int val);
	XMValueX operator= (float val);
//	XMValueX operator= (long float val);
	XMValueX operator= (double val);
	XMValueX operator= (long double val);
	
	// Oprateur d'opartion
	XMValueX operator+(XMValueX valx);
	XMValueX operator-(XMValueX valx);
	XMValueX operator*(XMValueX valx);
	XMValueX operator/(XMValueX valx);
	
	// Oprateur de comparaison
	bool operator<(XMValueX valx);
	bool operator>(XMValueX valx);
	bool operator<=(XMValueX valx);
	bool operator>=(XMValueX valx);
	bool operator==(XMValueX valx);
	void SetValue(TValueX type, void *val);
	
	char *GetFormat();
	void *GetValue();
	
	TValueX GetType();	
	void ConvertTo(TValueX tval);
};

