 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: intervalle.h,v 1.3 2001/03/18 22:35:02 daville Exp $
 * $Log: intervalle.h,v $
 * Revision 1.3  2001/03/18 22:35:02  daville
 * Ajout de lignes fin fichier.
 *
 * Revision 1.2  2000/11/02 22:10:22  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef INTERVALLE_H
#define INTERVALLE_H
#include "variable.h"

class XMIntervalle:public XMObjectX
{
	XMVariable *mBorne[2];
	XMVariable *mX;
	TYPE mStep;
public:
	XMIntervalle();
	XMIntervalle(XMVariable *inf, XMVariable *sup);
	XMIntervalle(char *name, XMVariable *inf, XMVariable *sup);
	XMIntervalle(double min, double max);
	void SetBorne(int num, XMVariable *born){if (mBorne[num]) delete mBorne[num];}; //0<==> infrieure; 1<==> suprieure;
	void ModifierBorne(int num, double val){mBorne[num]->SetValue(val);}; //0<==> infrieure; 1<==> suprieure;
	TYPE Inc();
	TYPE Dec();
	void Init();
	bool IsValid();
	bool Containt(double pt);
	double GetVal(int num){int v;return (mBorne[num]->Eval(v));};
	XMVariable *Point(){return mX;}
	
        char *Formatted();
	TYPE  Eval(int &i, CList <XMObjectX *> *lvar=NULL);
        char *EvalF(int &i, CList <XMObjectX *> *lvar=NULL){return (char *)0;}
        char *Affiche(){return (char *)0;}
        void  Lecture(){}
        XMObjectX *Diff(char *x){return (XMObjectX *)0;}
        XMObjectX *XEval(int &i, CList <XMObjectX *> *lvar=NULL){return (XMObjectX *)0;}
        XMObjectX *Clone(){return (XMObjectX *)0;}
	~XMIntervalle();
};


#endif	/* INTERVALLE_H */
