 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: loi.h,v 1.3 2001/04/03 23:13:24 daville Exp $
 * $Log: loi.h,v $
 * Revision 1.3  2001/04/03 23:13:24  daville
 * Ajout de lignes fin de fichier.
 *
 * Revision 1.2  2000/11/02 22:10:22  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef LOI_H
#define LOI_H
#include "type.h"
#include "calculator.h"

#define DIM_TAB	TO_UNKNOWN+1
#define OFFSET	(TO_UNKNOWN+1)
#define BEGINOFTAB	OFFSET
#define ENDOFTAB	TOP_LAST

typedef CCalculator<SObjectX>  *TABOperatorC[DIM_TAB][DIM_TAB];
typedef CCalculator<XMObjectX> *TABOperatorR[DIM_TAB][DIM_TAB];

static TABOperatorC *MainTABOpC[TOP_LAST-OFFSET];
static TABOperatorR *MainTABOpR[TOP_LAST-OFFSET];
static void *MAINTABOP[]={MainTABOpC, MainTABOpR, 0};

void *GetTAB(OnState st=ON_COMPILE);

void InitMainTab(OnState st=ON_COMPILE);
void CreateTABOperator(OnState st, TOperator op);
void RemoveTABOperator(OnState st, TOperator op);
void RemoveCalculator(OnState st, TOperator op, TObjectX lig, TObjectX col);
TObjectX GetTypeObjectX(OnState st, TOperator op, TObjectX lig, TObjectX col);
TObjectX GetTypeObjectXByChar(char type);
template <class T> void SetFunctionCalc(OnState st, TOperator op, TObjectX lig, TObjectX col, T* (*fcalc)(T*, T*));
template <class T> void SetCalculator(OnState st, TOperator op, TObjectX lig, TObjectX col, CCalculator<T> *pcal);
template <class T> T* GetResult(OnState st, TOperator op, T *objlig, T *objcol);
template <class T> CCalculator<T> *GetCalculator(OnState st, TOperator op, TObjectX lig, TObjectX col);


template <class T> T* GetResult(OnState st, TOperator op, T *objlig, T *objcol)
{
        TObjectX type;
        if (!objlig) type = TO_INIT; else type = objlig->Type();
        return ((CCalculator<T> ****)GetTAB(st))[op-OFFSET][objcol->Type()][type]->Evaluate(st,objlig, objcol);
}

template <class T>CCalculator<T> *GetCalculator(OnState st, TOperator op, TObjectX lig, TObjectX col)
{
        return ((CCalculator<T> ****)GetTAB(st))[op-OFFSET][col][lig];
}

template <class T> void SetCalculator(OnState st, TOperator op, TObjectX lig, TObjectX col, CCalculator<T> *pcal)
{
        ((CCalculator<T> ****)GetTAB(st))[op-OFFSET][col][lig] = pcal;
}

template <class T> void SetFunctionCalc(OnState st, TOperator op, TObjectX lig, TObjectX col, T* (*fcalc)(T*, T*))
{
        ((CCalculator<T> ****)GetTAB(st))[op-OFFSET][col][lig]->SetfCalc(fcalc);
}

#endif	/* LOI_H */

