 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: math.h,v 1.3 2001/04/04 20:57:38 daville Exp $
 * $Log: math.h,v $
 * Revision 1.3  2001/04/04 20:57:38  daville
 * Ajout de lignes fin de fichier.
 *
 * Revision 1.2  2000/11/02 22:10:08  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef MATHSFONCT
#define MATHSFONCT
#include "ArbreM.h"
#include "type.h"
#include "Liste.h"
#include "mobjectx.h"
#include "variable.h"

void val(char *s, TYPE & valeur, int &c);
void Decompress(char *ss, char *sd[]);


/*******     Modelisation d'un element dans pour le noeud      *****/  

class Element
{
        public:
        char *Nom;
        char *Vals;
        char *Vald;
        TYPE Val;
        Element();
        /*Element(Element &element);
        Element operator=(Element &element);
        ~Element();*/
};

void DestrucForCall(Element &Elt);

class XMFonction: public XMObjectX, ArbreM <Element>
{
        private:
        int Res;
        XMVariable **Variables;

        public:
        XMFonction();
        XMFonction(XMFonction & XMFonction);
        XMFonction(char *Exp);
        XMFonction(char *nom, char *Exp);
        XMFonction operator=(XMFonction XMFonction);
        XMFonction operator+(XMFonction &XMFonction);
        void Init();
        XMObjectX *Clone();
        char *Affiche();
        void Lecture();
        void PutVar(XMVariable *V, int pos);
        void SetVar(int Dim);
        void Ajout(char *s);
        void Permut(char *s);
        void DelParent();
        void FinArbre();
        char *Formatted(){return NULL;}
        TYPE Eval(int &Verite, CList <XMObjectX *> *lvar=NULL);
        char *EvalF(int &Verite, CList <XMObjectX *> *lvar=NULL);
        XMObjectX *XEval(int &i, CList <XMObjectX *> *lvar=NULL){return (XMObjectX *)0;}
        XMObjectX *Diff(char *VarDe);
        void Derivate(SNoeud *PSNoeu, char *VarDe);
        void Calcul(SNoeud *PSNoeu, CList<XMObjectX *> *lvar=NULL);
        void CalculF(SNoeud *PSNoeu);
        void Arbrer();
        XMVariable **GetPLV(){return Variables;};
        void InitDestForCall(){FONCTIONCALL=(void (*)(Element&))(&DestrucForCall);};
        ~XMFonction();
};

int EstStandard(char *Nom);
int Exist(XMVariable **Listx, char *NomVar, Variable &V);
XMVariable *GetVariable(XMVariable **Listx, char *NomVar);
void Update(Variable **Listx, CList <SObjectX *> *PLV);
void Convert(SNoeud *Ptrc, TYPE &Valg, TYPE &Vald);
void Convert_Diff(SNoeud *Ptrc, char **Valgs, char **Valds);
void ConvertF(SNoeud *Ptrc, char **Valgs, char **Valds);
int  Effectuer(SNoeud *Ptrc, CList<XMObjectX *> *lvar=NULL);
void EffectuerF(SNoeud *Ptrc, XMVariable **Listx);
void Derivee(SNoeud *Ptrc, char *VarDe);
#endif
