 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: motor3D.h,v 1.3 2001/04/04 21:03:22 daville Exp $
 * $Log: motor3D.h,v $
 * Revision 1.3  2001/04/04 21:03:22  daville
 * Ajout de lignes fin de fichier.
 *
 * Revision 1.2  2000/11/02 22:10:08  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef MOTOR3D_H
#define MOTOR3D_H
#include "vecteur.h"
#include "motor.h"

typedef struct CPoint;

class Motor3D: Motor
{
	TYPE  mTheta, mPhi;
	TYPE  mDistance;
	int * mOrg;
	int * mPtOfView;
	// La base
	TYPE * mI, *mJ, *mN;
public:
	Motor3D();
	Motor3D(int *Eye, int *org, TYPE distance, TYPE phi, TYPE theta);
	void Configure();
	void EvalXY(int &vld, TYPE *pt, TYPE *Res);
	int EvalX(int &vld, TYPE *pt);
	int EvalY(int &vld, TYPE *pt);

	void ConfigurerDist(double dist);
	void ConfigurerOrg(int org);
	void ConfigurerEye(int eye);
	void ConfigurerBase(TYPE phi, TYPE theta);
	double GetDist();
	int *GetOrg();
	int *GetEye(XMVecteur *eye);
	double GetBaseTheta();
	double GetBasePhi();
	void   GetI(TYPE *i);
	void   GetJ(TYPE *j);
	void   GetN(TYPE *n);
	void   GetBase(double *theta, double *phi);
	CPoint TroisDTo2D(XMVecteur M, bool *flag);
	virtual ~Motor3D();
};


#endif	/* MOTOR3D_H */
