 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: number.h,v 1.3 2001/04/04 21:12:34 daville Exp $
 * $Log: number.h,v $
 * Revision 1.3  2001/04/04 21:12:34  daville
 * Ajout de lignes fin de fichier.
 *
 * Revision 1.2  2000/11/02 22:09:52  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef NUMBER
#define NUMBER
#define SGNF 8
#include "TNumber.h"

/*****       Modelisation d'un nombre complexe   ****/

typedef struct SComplexe
{
        TYPE Im;
        TYPE Re;
}SComplexe;


/********     Modelisation d'une variable      ******/
typedef struct Variable
{
        char *Nom;
        TYPE Dep;
        TYPE Fin;
        TYPE X;
        char *Xs;
}Variable;

typedef struct EltDerive
{
        char *Nom;
        int Nbre;
}EltDerive;

/* Prototipage pour le fonctions standards */
/*double fmod(double, double);
double abs(double);
double pow(double, double);
double log(double);
double exp(double);
double sin(double);
double cos(double);
double tan(double);*/
/**/

TYPE Pgdc(TYPE x,TYPE y);       
char *Simplifie_Somme(char *Valgs, char *Valds);
char *Simplifie_Soust(char *Valgs, char *Valds);
char *Simplifie_Multi(char *Valgs, char *Valds);
char *Simplifie_Power(char *Valgs, char *Valds);
char *Simplifie_Quot(char *Valgs,char *Valds);
char *Simplifie_Ln(char *Valds);
char *Simplifie_Abs(char *Valds);
char *Simplifie_Exp(char *Valds);
char *Simplifie_Cos(char *Valds);
char *Simplifie_Sin(char *Valds);
char *Simplifie_Tan(char *Valds);
char *Simplifie_Ch(char *Valds);
char *Simplifie_Sh(char *Valds);
char *Simplifie_Th(char *Valds);
char *Simplifie_Arctan(char *Valds);
char *Simplifie_Arccos(char *Valds);
char *Simplifie_Arcsin(char *Valds);
char *Simplifie_Argth(char *Valds);
char *Simplifie_Sqrt(char *Valds);
#endif
