 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: ploter.h,v 1.3 2001/04/03 23:52:59 daville Exp $
 * $Log: ploter.h,v $
 * Revision 1.3  2001/04/03 23:52:59  daville
 * Ajout de lignes fin de fichier.
 *
 * Revision 1.2  2000/11/02 22:09:52  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef PLOTER_H
#define PLOTER_H
#include "Liste.h"
#include "intervalle.h"
#include "mtdplot.h"


class XMPloter: public XMObjectX
{
protected:
	XMMethodPlot *mMethod;
	CList <XMObjectX *> *mAPloter;
	CList <XMIntervalle *> *mIntervalles;
public:
	XMPloter();
	XMPloter(char *meth);
	XMPloter(TMethod meth);
	XMPloter(XMObjectX *ob, TMethod meth=TM_CARTESIAN2D);
	XMPloter(TMethod meth, CList<XMObjectX *> *pobj, CList<XMIntervalle *> *inter);
	void Add(XMObjectX *obj);
	void SetMethode(TMethod metd);
	int Dim();
	CList <XMIntervalle *> *Intervalles();
	void *Map(CList <XMObjectX *> *lvar);
	XMMethodPlot * Method();
	TYPE **Reach(int &vld, TYPE **pt, TYPE **Res);
	
        char *Formatted(){return NULL;}
	TYPE  Eval(int &i, CList <XMObjectX *> *lvar=NULL){return 0;}
        char *EvalF(int &i, CList <XMObjectX *> *lvar=NULL){return (char *)0;}
        char *Affiche(){return (char *)0;}
        void  Lecture();
        XMObjectX *XEval(int &i, CList <XMObjectX *> *lvar=NULL){return (XMObjectX *)0;}
        XMObjectX *Diff(char *x){return (XMObjectX *)0;}
        XMObjectX *Clone(){return (XMObjectX *)0;}
	
	~XMPloter();
};

#endif	/* XMPloter_H */
