 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: polynome.h,v 1.3 2001/04/03 23:52:59 daville Exp $
 * $Log: polynome.h,v $
 * Revision 1.3  2001/04/03 23:52:59  daville
 * Ajout de lignes fin de fichier.
 *
 * Revision 1.2  2000/11/02 22:09:51  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <stdio.h>
#ifndef POLY
#define POLY

typedef struct SPol
{
        float X;
        char *Xs;
}SPol;

template <class T> T Max(T x, T y);
template <class T> T Min(T x, T y);

class Polynome
{
        private:
        	SPol *Po;
        	int Deg;
        public:
        	Polynome();
        	Polynome(int deg);
        	Polynome(Polynome &P);
        	void SetDeg(int D);
        	void Set(int i, float x);
        	void Lire();
        	void Lires();
        	int  Degre(){return Deg;};
        	void Refresh();
        	char *Formatted(){return NULL;}
        	Polynome &operator= (Polynome P);
        	Polynome operator+ (Polynome &P);
        	Polynome operator- (Polynome &P);
        	Polynome operator* (Polynome &P);
        friend  Polynome Reduction(Polynome P1, Polynome P2, Polynome &Reste);
        	float operator[](int i);
        	~Polynome();
};

#endif


