 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: vecteur.cpp,v 1.3 2001/04/03 23:46:25 daville Exp $
 * $Log: vecteur.cpp,v $
 * Revision 1.3  2001/04/03 23:46:25  daville
 * Ajout de return et des lignes fin de fichier.
 *
 * Revision 1.2  2000/11/02 22:09:51  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include "vecteur.h"

XMVecteur::XMVecteur()
{
	mType = TO_VECTEUR;
        mDim = 0;
        mVect = NULL;
}

XMVecteur::XMVecteur(XMVecteur &vect)
{
	mType = TO_VECTEUR;
        mDim = vect.mDim;
        mVect = NULL;
        if (!mDim) return;
        mVect = new (XMObjectX*)[mDim];
        for (int i=0; i<mDim; i++) mVect[i] = (vect.mVect[i])->Clone();
}

XMVecteur::XMVecteur(int dim)
{
	mType = TO_VECTEUR;
        mDim = dim;
        if (!mDim) return;
        mVect = new (XMObjectX*)[mDim];
}

void XMVecteur::SetDim(int dim)
{
        mDim = dim;
        if (!mDim) return;
        mVect = new (XMObjectX*)[mDim];
}

int  XMVecteur::GetDim()
{
        return mDim;
}

void XMVecteur::SetCoord(XMObjectX *mobj, int rg)
{
        mVect[rg] = mobj;
}

XMObjectX *XMVecteur::GetCoord(int rg)
{
        return mVect[rg];
}

void XMVecteur::DeleteCoord(int rg)
{
        if (!mVect[rg]) return;
        delete (mVect[rg]);
        mVect[rg] = NULL;
}

XMObjectX *XMVecteur::Clone()
{
        return new XMVecteur(*this);
}

XMObjectX *XMVecteur::Diff(char *x)
{
        XMVecteur *vect;
        char *nom;
        vect = new XMVecteur(mDim);
        nom = new char[strlen(mName)+2];
        sprintf(nom, "%s'", mName);
        vect->SetName(nom);
        for (int i=0; i<mDim; i++) vect->mVect[i] = mVect[i]->Diff(x);
        delete nom;
        return vect;
}

char *XMVecteur::Formatted()
{
	char *formatted;
	char Temp1[200], Temp2[200];
	formatted = new char[1000];
	//for (int j=0; j<m
	sprintf(formatted, "%d#%s#", mType, mName);
	return formatted;
}

void XMVecteur::Lecture()
{
}

char *XMVecteur::Affiche()
{
	return NULL;
}

char *XMVecteur::EvalF(int &vld, CList <XMObjectX *> *lvar=NULL)
{
	return NULL;
}

TYPE XMVecteur::Eval(int &vld, CList <XMObjectX *> *lvar=NULL)
{
	return 0;
}

XMVecteur::~XMVecteur()
{
        if (!mDim) return;
        for (int i=0; i<mDim; i++) DeleteCoord(i);
        delete mVect;
        mVect = NULL;
	mType = TO_UNKNOWN;
}

