 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: whole.cpp,v 1.3 2001/04/03 23:43:40 daville Exp $
 * $Log: whole.cpp,v $
 * Revision 1.3  2001/04/03 23:43:40  daville
 * Ajout de lignes fin de fichier.
 *
 * Revision 1.2  2000/11/02 22:09:34  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include "whole.h"


XMWhole::XMWhole()
{
	mWhole = NULL;
	mType = TO_WHOLE;
}

XMWhole::XMWhole(char *name):XMObjectX(NULL,NULL,name)
{
	mWhole=NULL;
	mType = TO_WHOLE;
}

XMWhole::XMWhole(CList <XMObjectX *> *lo)
{
	mType = TO_WHOLE;
	mWhole = lo;
}

CList <XMObjectX *> *XMWhole::Get()
{
	return mWhole;
}

void XMWhole::Add(XMObjectX *obj)
{
	if (!obj) return;
	if (!mWhole) mWhole = new CList <XMObjectX *>;
	mWhole->Add(obj);
}

char *XMWhole::Formatted()
{
	char *formatted;
	
	formatted = new char[1000];
	sprintf(formatted, "%d#%s#", mType, mName);
	return formatted;
}

TYPE  XMWhole::Eval(int &i, CList <XMObjectX *> *lvar=NULL)
{
	return 0;
}

char *XMWhole::EvalF(int &i, CList <XMObjectX *> *lvar=NULL)
{
	return (char *)0;
}

char *XMWhole::Affiche()
{
	return (char *)0;
}

void  XMWhole::Lecture()
{
}

XMObjectX *XMWhole::XEval(int &i, CList <XMObjectX *> *lvar=NULL)
{
	return (XMObjectX *)0;
}

XMObjectX *XMWhole::Diff(char *x)
{
	return (XMObjectX *)0;
}

XMObjectX *XMWhole::Clone()
{
	return (XMObjectX *)0;
}

XMWhole::~XMWhole()
{
}

