 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: xmgthread.cpp,v 1.3 2001/04/03 23:41:14 daville Exp $
 * $Log: xmgthread.cpp,v $
 * Revision 1.3  2001/04/03 23:41:14  daville
 * Ajout de lignes fin de fichier.
 *
 * Revision 1.2  2000/11/02 22:09:34  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <xmgthread.h>

void GThreadInit(GThreadFunctions* init)
{
	g_thread_init (init);
}

GThreadAttr *GThreadAttrSetDetachState(GThreadAttr *pthread_attr, GThreadProperty prop=PTHREAD_CREATE_JOINABLE)
{
	pthread_attr_setdetachstate(pthread_attr, prop);
	return (pthread_attr);
}

GThreadAttr *GThreadAttrInit(GThreadAttr *pthread_attr)
{
	pthread_attr_init(pthread_attr);
	return (pthread_attr);
}

GPointer GThreadCreate(GThreadFunction func, GPointer data, GThreadAttr *pthread_attr)
{
	pthread_t thread;
	/* This is the default, it seems, so leave that out for now
	pthread_attr_setdetachstate (&pthread_attr, PTHREAD_CREATE_JOINABLE);
	*/
	if (data) pthread_create (&thread, pthread_attr,  (void *(*)(void *))func, data);
	else pthread_create (&thread, pthread_attr, (void *(*)(void *)) func, data);
	return GUINT_TO_POINTER (thread);
}

void GThreadJoin(GPointer id, GPointer result)
{
	pthread_join((pthread_t)id, &result);
}

void GThreadWait(double seconds)
{
	GMutex *mutex;
	GCond *cond;
	GTimeVal current_time;

	g_get_current_time (&current_time);
	mutex = g_mutex_new ();
	cond = g_cond_new ();

	current_time.tv_sec += (guint) seconds;
	seconds -= (guint) seconds;
	current_time.tv_usec += (guint) (seconds * G_MICROSEC);
	while (current_time.tv_usec >= G_MICROSEC)
	{
		current_time.tv_usec -= G_MICROSEC;
		current_time.tv_sec++;
	}

	g_mutex_lock (mutex);
	g_cond_timed_wait (cond, mutex, &current_time);
	g_mutex_unlock (mutex);

	g_mutex_free (mutex);
	g_cond_free (cond);
}

void GThreadFree(GPointer data)
{
	g_free (data);
}
