 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: xmgthread.h,v 1.3 2001/04/03 23:41:14 daville Exp $
 * $Log: xmgthread.h,v $
 * Revision 1.3  2001/04/03 23:41:14  daville
 * Ajout de lignes fin de fichier.
 *
 * Revision 1.2  2000/11/02 22:09:34  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef XMGTHREAD_H
#define XMGTHREAD_H

#include <glib.h>
#include <pthread.h>

#define G_MICROSEC 1000000

class CGThread{};
typedef gpointer GPointer;
typedef pthread_attr_t GThreadAttr;
typedef int GThreadProperty;
typedef GHookFunc GThreadFunction;

void GThreadInit(GThreadFunctions* init);
GThreadAttr *GThreadAttrSetDetachState(GThreadAttr *pthread_attr, GThreadProperty prop=PTHREAD_CREATE_JOINABLE);
GThreadAttr *GThreadAttrInit(GThreadAttr *pthread_attr);
GPointer GThreadCreate(GThreadFunction func, GPointer data, GThreadAttr *pthread_attr);
void GThreadJoin(GPointer id, GPointer result);
void GThreadWait(double seconds);
void GThreadFree(GPointer data);

#endif  /* XMGTHREAD_H */
