#! /bin/sh
 ########################################################################
 # =======================================				#
 # EasyMaths - Configuration component of EasyMaths			#
 # November 2000							#
 # =======================================				#
 #									#
 # Copyright (C) 2000, 2001 Didier Davill				#
 # Developed by Didier Davill <Didier.Daville@ddarea.com>		#
 #									#
 # This library is free software; you can redistribute it and/or modify #
 # it under the terms of the GNU Library General Public License as 	#
 # published by the Free Software Foundation; either version 2 of the	#
 # License, or (at your option) any later version.			#
 #									#
 # This library is distributed in the hope that it will be useful, but	#
 # WITHOUT ANY WARRANTY; without even the implied warranty of		#
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			#
 # See the GNU Library General Public License for more details.		#
 #									#
 # You should have received a copy of the GNU Library General Public	#
 # License along with this library; if not, write to the Free Software	#
 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		#
 # 02111-1307, USA.							#
 ########################################################################

 ########################################################################
 # $Author: daville $
 #
 # $Revision: 1.8 $
 #
 # $Id: Easymaths-config.sh,v 1.8 2001/04/16 01:43:14 daville Exp $
 # $Log: Easymaths-config.sh,v $
 # Revision 1.8  2001/04/16 01:43:14  daville
 # Modification fi  ==> else
 #
 # Revision 1.7  2001/04/16 01:40:51  daville
 # Modification du test sur la variable EASYMATHS_FICHIER_CONFIG.
 #
 # Revision 1.6  2001/04/15 22:53:18  daville
 # Traitement de recherche du fichier de configuration (Setup.conf)
 #
 # Revision 1.5  2001/04/15 14:10:08  daville
 # Rcupration de la version pour la prsentation.
 #
 # Revision 1.4  2000/11/05 20:10:31  daville
 # Intgration de la variable des variables EASYMATHS_H
 #
 # Revision 1.3  2000/11/05 17:14:56  daville
 # Intgration des termes de GNU. Et ajout d'une variable d'environnement pour le fichier de configuration de l'installation.
 #
 #
 ########################################################################


#########################################
#	  Easymaths-config.sh		#
#					#
#########################################

VERSION=`echo "$Revision: 1.8 $"|cut -d" " -f2`

function AfficherAide ( )
{
cat <<FIN

 ************************************************
  Easymaths-config version $VERSION
  Copyright (C) 2000 EasyMaths of Didier Davill
  Easymaths-config comes with ABSOLUTELY NO WARRANTY.
  This is free software, and you are welcome to
  redistribute it under certain conditions.
 *************************************************

FIN
	echo "Easymaths-config [OPTION]"
	echo "Avec [OPTION]"
	echo "		-h ? --help			affiche ce message"
	echo "		-hm --home			retourne l'emplacement de EasyMaths"
	echo "		-ve --version			retourne la version de l'interface EasyMaths"
	echo "		-vc --versioncore		retourne la version du noyau de EasyMaths"
	echo "		-ihmldir --ihmlibdir		retourne l'emplacement des librairies de l'interface EasyMaths"
	echo "		-ihmidir --ihmincludedir	retourne l'emplacement des headers de l'interface EasyMaths"
	echo "		-coreldir --corelibdir		retourne l'emplacement des librairies de l'interface EasyMaths"
	echo "		-coreidir --coreincludedir	retourne l'emplacement des headers de l'interface EasyMaths"
	echo "		-ihml --ihmlibs			retourne les librairies de l'interface EasyMaths"
	echo "		-ihmc --ihmincludes		retourne les headers de l'interface EasyMaths"
	echo "		-corel --corelibs		retourne les librairies de l'interface EasyMaths"
	echo "		-corec --coreincludes		retourne les headers de l'interface EasyMaths"
	echo "		-n --name			retourne le nom de l'excutable EasyMaths"
}

function ChargerParametre ( )
{
	LIGNE=`grep $1= $EASYMATHS_FICHIER_CONFIG`
	PARAMETRE_CONFIG=`echo $LIGNE|cut -d= -f2`
}

function ProcedurePrincipale ( )
{
	if [ $# = 0 ]; then
		AfficherAide
	fi
	if [ ! $EASYMATHS_FICHIER_CONFIG ]; then
		if [  -f ../EasyMaths/Setup.conf ]; then
			EASYMATHS_FICHIER_CONFIG="../EasyMaths/Setup.conf"
		else
			echo
			echo "Le fichier de configuration n'a pas t trouv aux emplacements standards"
			echo "Positionner la variable d'environnement 'EASYMATHS_FICHIER_CONFIG'"
			echo "sur le fichier de configuration ou renomm le '../EasyMaths/Setup.conf' "
			echo
		fi
	fi	
	case $1 in
		?) AfficherAide;;
		-h) AfficherAide;;
		--help) AfficherAide;;
		--name)
			ChargerParametre EASYMATHS_NAME
			echo $PARAMETRE_CONFIG;;
		-n)
			ChargerParametre EASYMATHS_NAME
			echo $PARAMETRE_CONFIG;;
		--home)
			ChargerParametre EASYMATHS_HOME
			echo "$PARAMETRE_CONFIG";;
		-hm)
			ChargerParametre EASYMATHS_HOME
			echo "$PARAMETRE_CONFIG";;
		--version)
			ChargerParametre EASYMATHS_VERSION
			echo "$PARAMETRE_CONFIG";;
		-ve)
			ChargerParametre EASYMATHS_VERSION
			echo "$PARAMETRE_CONFIG";;
		--versioncore)
			ChargerParametre CORE_VERSION
			echo $PARAMETRE_CONFIG;;
		-vc)
			ChargerParametre CORE_VERSION
			echo $PARAMETRE_CONFIG;;
		--ihmlibdir)
			ChargerParametre IHM_LIBRAIRIES_DIR
			echo $PARAMETRE_CONFIG;;
		-ihmldir)
			ChargerParametre IHM_LIBRAIRIES_DIR
			echo $PARAMETRE_CONFIG;;
		--corelibdir)
			ChargerParametre CORE_LIBRAIRIES_DIR
			echo $PARAMETRE_CONFIG;;
		-coreldir)
			ChargerParametre CORE_LIBRAIRIES_DIR
			echo $PARAMETRE_CONFIG;;
		--ihmincludedir)
			ChargerParametre IHM_INCLUDES_DIR
			echo $PARAMETRE_CONFIG;;
		-ihmidir)
			ChargerParametre IHM_INCLUDES_DIR
			echo $PARAMETRE_CONFIG;;
		--coreincludedir)
			ChargerParametre CORE_INCLUDES_DIR
			echo $PARAMETRE_CONFIG;;
		-coreidir)
			ChargerParametre CORE_INCLUDES_DIR
			echo $PARAMETRE_CONFIG;;
		--ihmlibs)
			ChargerParametre IHM_LIBRAIRIES
			echo $PARAMETRE_CONFIG;;
		-ihml)
			ChargerParametre IHM_LIBRAIRIES
			echo $PARAMETRE_CONFIG;;
		--corelibs)
			ChargerParametre CORE_LIBRAIRIES
			echo $PARAMETRE_CONFIG;;
		-corel)
			ChargerParametre CORE_LIBRAIRIES
			echo $PARAMETRE_CONFIG;;
		--ihmincludes)
			ChargerParametre IHM_INCLUDES
			echo $PARAMETRE_CONFIG;;
		-ihmc)
			ChargerParametre IHM_INCLUDES
			echo $PARAMETRE_CONFIG;;
		--coreincludes)
			ChargerParametre CORE_INCLUDES
			echo $PARAMETRE_CONFIG;;
		-ihmc)
			ChargerParametre CORE_INCLUDES
			echo $PARAMETRE_CONFIG;;
		-getparam)
			ChargerParametre "$2"
			echo $PARAMETRE_CONFIG;;
	esac
}

ProcedurePrincipale $*
