 /***********************************************************************
 * =======================================				*
 * EasyMaths - IHM component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.4 $
 *
 * $Id: ClientCommunication.h,v 1.4 2001/04/04 20:13:07 daville Exp $
 * $Log: ClientCommunication.h,v $
 * Revision 1.4  2001/04/04 20:13:07  daville
 * Ajout de lignes fin de fichier.
 *
 * Revision 1.3  2000/11/04 08:40:44  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 * Revision 1.2  2000/11/02 22:29:12  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef CLIENT_COMMUNICATION_H
#define CLIENT_COMMUNICATION_H

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <XMProtocol.h>
#include <pthread.h>

class HandleServer;

SCConnection *ConnectToServer(char *adresse);
int SendToServer(SCConnection * con, XMQuery *query);
int ListenToServer(SCConnection * con, int status, HandleServer *hdle);
XMReponse * ReceiveFromServer(SCConnection * con);
int DisconnectToServer(SCConnection * con);
int ShutdownServer(SCConnection * con);

XMQuery *InitQuery(XMQuery *query);
XMQuery *MakeQuery(XMQuery *query, int id_client, int id_query, char *data);
int 	 ReadReponse(XMReponse *reponse, int &id_client, int &id_query, char *data);

void SetThreadWait(double pause);

class HandleServer
{
	public : virtual void TreateReponse(XMReponse *reponse)=0;
};

#endif  /* XMCORE_H */

