 /***********************************************************************
 * =======================================				*
 * EasyMaths - IHM component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.4 $
 *
 * $Id: FileArch.cc,v 1.4 2001/04/14 14:32:19 daville Exp $
 * $Log: FileArch.cc,v $
 * Revision 1.4  2001/04/14 14:32:19  daville
 * Ajout de +1 pour le appels new char.
 *
 * Revision 1.3  2001/04/04 20:16:02  daville
 * Ajout de lignes fin de fichier.
 *
 * Revision 1.2  2000/11/02 22:29:12  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <stdio.h>
#include <libgen.h>
#include <FileArch.h>

FileArch::FileArch(int max)
{
	mPosition = mMax = 0;
	if (max < 0) return;
	mMax = max;
	mTABItemFileArch = new (char *)[mMax];
	for(int i=0; i<mMax; i++) mTABItemFileArch[i] = NULL;
}

void FileArch::AddItemFileArch(VDKMenu *menu, char *itemu, bool (VDKObject::*Hld)(VDKObject *sender))
{
	VDKMenuItem* pItemMenu;
	if (mPosition == mMax) DelItemFileArch(mMax-1, NULL);
	for (int k=mPosition; k>=1; k--) mTABItemFileArch[k] = mTABItemFileArch[k-1];
	mTABItemFileArch[0] = new char[strlen(itemu)+1];
	strcpy(mTABItemFileArch[0], itemu);
	mPosition++;
	Rafraichir(menu, Hld);
	//CheckedItemFichier(NULL, item->GetMenuItem());
}

void FileArch::DelItemFileArch(int pos, char *name)
{
	int k, ASupprimer=-1;
	if (pos >= mMax) return;
	if ((pos<0) && (!name))
	{
		for (k=0; mTABItemFileArch[k]; k++)
		{
			/* DEBUT_BUGS */
			/* Il faut dsalouer la mmoire allouer */
			/* //delete mTABItemFileArch[k]; */
			/* FIN_BUGS */
			//delete mTABItemFileArch[k];
			mTABItemFileArch[k]=NULL;
		}
		mPosition=0;
		return;
	}
	if (pos<0)
	{
		for (k=0; k<mPosition; k++)
			if (!strcmp(mTABItemFileArch[k], name)) ASupprimer = k;
	} else ASupprimer = pos;
	mPosition--;
	for (k=ASupprimer; k<mMax; k++) mTABItemFileArch[k] = mTABItemFileArch[k+1];
	delete mTABItemFileArch[k];
	mTABItemFileArch[k] = NULL;
}

void FileArch::CheckedItemFichier(char *name, VDKMenuItem *item)
{
	/*int pos;
	bool IsFound = false;
	if (name != NULL)
	{
		for (pos=0; pos<mPosition; pos++) IsFound = !strcmp(mTABItemFileArch[pos]->GetName(), name);
	} else
	{
		for (pos=0; pos<mPosition; pos++) IsFound = (mTABItemFileArch[pos]->GetMenuItem() == item);
	}*/
	//if (IsFound) mTABItemFileArch[i]->GetItem()->
}

void FileArch::Rafraichir(VDKMenu *menu, bool (VDKObject::*Hld)(VDKObject *sender))
{
	VDKMenuItem* pItemMenu;
	for (int k=0; k<mPosition; k++)
	{
		pItemMenu = new VDKMenuItem(menu, basename(mTABItemFileArch[k]), NULL);
		SignalConnect(pItemMenu, "activate_signal", Hld, false, true);
	}
}

/*
ItemFileArch *FileArch::GetItemFileArch(char *item)
{
	/*char *aItem=NULL;
	for (int k=0; (aItem = mTABItemFileArch[k]) && (k<mMax); k++)
		if (aItem->GetMenuItem() == item) return aItem;
	return NULL;
}*/

FileArch::~FileArch()
{
	for (int k=0; mTABItemFileArch[k]; k++)
		delete (mTABItemFileArch[k]);
	delete mTABItemFileArch;
	mTABItemFileArch = NULL;
}

/******************************************************************************************************/
/******************************************************************************************************/
/******************************************************************************************************/
/******************************************************************************************************/
ItemFileArch::ItemFileArch()
{
	mItem = NULL;
	mName = NULL;
}

ItemFileArch::ItemFileArch(VDKMenuItem *item, char *name)
{
	mItem = item;
	mName = NULL;
	if (!name) return;
	mName = new char[strlen(name)+1];
	strcpy(mName, name);
}

void ItemFileArch::SetName(char *name)
{
	if (mName) delete mName;
	mName = NULL;
	if (!name) return;
	mName = new char[strlen(name)+1];
	strcpy(mName, name);
}

char *ItemFileArch::GetName()
{
	return mName;
}

VDKMenuItem *ItemFileArch::GetMenuItem()
{
	return mItem;
}

ItemFileArch::~ItemFileArch()
{
	if (mName) delete mName;
	mName = NULL;
}

