 /***********************************************************************
 * =======================================				*
 * EasyMaths - IHM component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.4 $
 *
 * $Id: HandlersWEAS.cc,v 1.4 2001/04/14 14:33:37 daville Exp $
 * $Log: HandlersWEAS.cc,v $
 * Revision 1.4  2001/04/14 14:33:37  daville
 * Rduction du tempps d'attente pour lee temps
 *
 * Revision 1.3  2001/04/04 20:18:19  daville
 * Ajout de return pour les fonction retournant des valeurs.
 *
 * Revision 1.2  2000/11/02 22:29:12  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <vdk/vdk.h>
#include <vdk/FileDialog.h>
#include <vdk/FileSaveAsDialog.h>
#include <vdk/menu.h>
#include <easymaths.h>
#include <about.h>
#include <bibliotheque.h>
#include <progress.h>
#include <libgen.h>
#include <../Core/XMValueX.h>
#include <ToolsXMProtocol.h>
#include <pthread.h>

bool EasymathsForm::FINouveau(VDKObject *sender)
{
	mTextin->Clear();
	mTextout->Clear();
	
	mCurrentFile[0] = '\0';
	return true;
}

bool EasymathsForm::FIOuvrir(VDKObject *sender)
{
	FileStringArray selection;
	VDKFileDialog *child = new VDKFileDialog(Application()->MainForm,&selection, "Open File");
	child->Filter = "*.xm";
	child->ShowModal();
	if (selection.size())
	{
		mTextin->Clear();
		mTextout->Clear();
		if (mTextin->LoadFromFile((char *)selection[0])!=TRUE)
		{
			char msg[600];
			sprintf(msg,"Problme d'ouverture du fichier\n%s", (char *)selection[0]);
			Application()->MessageBox("Error", msg, MB_OK);
			mCurrentFile[0] = '\0';
		} else
		{
			sprintf(mCurrentFile, selection[0]);
			InitialiserMenuFichiers();
			mListOldFile->AddItemFileArch(mMenu0070, mCurrentFile,
						(bool (VDKObject::*)(VDKObject *))(&EasymathsForm::HMenuItemFichier));
			UpdateTitle(false);
		}
	} else mTextout->TextInsert("Fail desol!!!\n");
	return true;
}

bool EasymathsForm::FIFermerFichier(VDKObject *sender)
{
	return true;
}

bool EasymathsForm::FIEnregistrer(VDKObject *sender)
{
	if (*mCurrentFile)
	{
		if (mTextin->SaveToFile(mCurrentFile)==TRUE)
		{
			mTextin->Changed = FALSE;
			UpdateTitle(false);
		}else
		{
			char msg[400];
			sprintf(msg,"Problme de sauvegarde du fichier %s\n", mCurrentFile);
			Application()->MessageBox("Error", msg, MB_OK);
		}
	} else return FIEnregistrerSs(sender);
	return true;
}

bool EasymathsForm::FIEnregistrerSs(VDKObject *sender)
{
	FileStringArray selections;
	char temp[500];
	VDKFileSaveAsDialog *child = new VDKFileSaveAsDialog(Application()->MainForm,&selections, "Save as");
	child->Filter = "*.xm";
	child->ShowModal();
	for (int t = 0; t<selections.size(); t++)
	{
		sprintf(mCurrentFile, selections[t]);
		FIEnregistrer(sender);
	}
	return true;
}

bool EasymathsForm::FIViderLaListe(VDKObject *sender)
{
	mListOldFile->DelItemFileArch(-1, NULL);
	InitialiserMenuFichiers();
	return true;
}

bool EasymathsForm::HMenuItemFichier(VDKObject *sender)
{
	printf("Hello %s\n");
	/*
		mListOldFile->GetItemFileArch((VDKMenuItem *)sender)->GetName());*/
	return true;
}

bool EasymathsForm::FIConfigurerImp(VDKObject *sender)
{
	return true;
}

bool EasymathsForm::FIImprimer(VDKObject *sender)
{
	return true;
}

bool EasymathsForm::FIMiseEnPage(VDKObject *sender)
{
	return true;
}

bool EasymathsForm::FIFermer(VDKObject *sender)
{
	return true;
}

bool EasymathsForm::FIQuitter(VDKObject *sender)
{
        return Quitter(sender);
}

bool EasymathsForm::EDAnnuler(VDKObject *sender)
{
	return true;
}

bool EasymathsForm::EDCouper(VDKObject *sender)
{
	return true;
}

bool EasymathsForm::EDCopier(VDKObject *sender)
{
	return true;
}

bool EasymathsForm::EDColler(VDKObject *sender)
{
	return true;
}

bool EasymathsForm::EDSelectionnerTout(VDKObject *sender)
{
	return true;
}

bool EasymathsForm::BIStandard(VDKObject *sender)
{
	BibliothequeForm *child = new BibliothequeForm(Application()->MainForm, "Bibliothque standard");
	child->Setup();
	child->SetMode(1);
	child->ShowModal();
	return true;
}

bool EasymathsForm::BIEasyMaths(VDKObject *sender)
{
	BibliothequeForm *child = new BibliothequeForm(Application()->MainForm, "Bibliothque de EasyMaths");
	child->Setup();
	child->SetMode(2);
	child->ShowModal();
	return true;
}

bool EasymathsForm::BIUtilisateur(VDKObject *sender)
{
	BibliothequeForm *child = new BibliothequeForm(Application()->MainForm, "Bibliothque utilisateur");
	child->Setup();
	child->SetMode(3);
	child->ShowModal();
	return true;
}


bool EasymathsForm::VUView2D(VDKObject *sender)
{
	return true;
}

bool EasymathsForm::VUView3D(VDKObject *sender)
{
	return true;
}

bool EasymathsForm::OPFenetre(VDKObject *sender)
{
	return true;
}

bool EasymathsForm::OPGraphe(VDKObject *sender)
{
	return true;
}

bool EasymathsForm::OPPile(VDKObject *sender)
{
	return true;
}

bool EasymathsForm::OUDocument(VDKObject *sender)
{
	return true;
}

bool EasymathsForm::AIAide(VDKObject *sender)
{
	return true;
}

bool EasymathsForm::AIAideCont(VDKObject *sender)
{
	return true;
}

bool EasymathsForm::AIAideAPP(VDKObject *sender)
{
        AboutForm *child = new AboutForm(Application()->MainForm, "A propos de EasyMaths");
	child->Setup();
	child->ShowModal();
	return true;
}

bool EasymathsForm::HandleToolbarSys(VDKObject *sender)
{
    VDKToolbar *tbar = reinterpret_cast<VDKToolbar *>(sender);
    if (!tbar) return TRUE;

    int id = tbar->ButtonPressed;
    switch (id)
    {
	case 0: // Nouveau
            return FINouveau(sender);
            break;
	case 1: // Ouvrir
            return FIOuvrir(sender);
            break;
	case 2: // Excuter
		/*{
			pthread_t thread;
			pthread_attr_t pthread_attr;
			
			pthread_attr_init(&pthread_attr);
			pthread_create (&thread, &pthread_attr, (void * (*)(void *))(&LancerRun), sender);
		 }*/
		 return Run(sender);
            break;
	case 3: // Quitter
            return FIQuitter(sender);
            break;
    }
    return TRUE;
}

bool EasymathsForm::HandleToolbarMat(VDKObject *sender)
{
    VDKToolbar *tbar = reinterpret_cast<VDKToolbar *>(sender);
    if (!tbar) return TRUE;

    int id = tbar->ButtonPressed;
    mTextin->TextInsert(EAS_TEXT_GENERATED[id]);
    return TRUE;
}

bool EasymathsForm::HandleTextIn(VDKObject *sender)
{
	if ((mTextin->Changed == true) && (mTitle[strlen(mTitle) - 2] == ' ')) UpdateTitle(true);
	return true;
}

bool EasymathsForm::HandleTextOut(VDKObject *sender)
{
	return true;
}

////////////////////////////////////////////////////////////////////////////
//     Section effectuant la communication avec le module Mathmatique   ///
////////////////////////////////////////////////////////////////////////////
/*
//  Filtrage de la rponse envoye
void EasymathsForm::FilterReponseCreate(CReponse *fReponse)
{
    char text[500];
    switch (fReponse->IDRep)
    {
        case TR_VOID:
            {
                char *err = fReponse->GetAfficher();
		sprintf(text,"Void %d addr(%p)", TR_VOID, fReponse);
		mTextout->TextInsert(text);
                sprintf(text, "\n%s\n",err);
		mTextout->TextInsert(text);
                delete err;
                break;
            }
        case TR_ERROR:
            {
                char *err = fReponse->GetAfficher();
                printf("[FAIL %d] ", TR_ERROR);
                printf("\n%s\n",err);
                delete err;
                break;
            }
        case TR_OK:
        	sprintf(text,"[PASS]:  ");
	        mTextout->TextInsert(text);
	        TreateObjectX((XMObjectX *)(fReponse->ObjX));
	        break;
        case TR_EXIT:
	        printf("Quitter %d", TR_EXIT);
	        break;
        case TR_INFO:
	        printf("Info %d", TR_INFO);
	        break;
        default:
	        sprintf(text,"Rien");
		mTextout->TextInsert(text);
    }
}*/


void EasymathsForm::TreateReponse(XMReponse *aRep)
{
	switch (aRep->IDReponse)
	{
		case XMRAVANCEMENT:
			if (mProgress)
			{
				mProgress->UpdateProgress(
					GetField(aRep->Reponse, 1, 1),
					GetField(aRep->Reponse, 2, 2),
					GetField(aRep->Reponse, 3, 3),
					GetField(aRep->Reponse, 4, 4),
					GetField(aRep->Reponse, 5, 5));
				SetThreadWait(0.005);
			}
			break;
		case XMRINFO:
			break;
		case XMRERROR:
			break;
		case XMROK:
			if (mProgress != NULL)
			{
				mProgress->Close();
				SetThreadWait(1.5);
				//sleep(1); //for (int k=0;k<9999;k++);
				SetThreadWait(0.03);
			}
			TreateObjectX(aRep);
			break;
	}
	for(;gtk_events_pending();gtk_main_iteration());
}


// Filtrage de l'objet renvoy
void EasymathsForm::TreateObjectX(XMReponse *obj)
{
	char text[1000];
	printf("%s\n", obj->Reponse);
        switch (atoi(GetField(obj->Reponse, 0, 0)))
        {
                case TO_UNKNOWN:
                	sprintf(text, "EasyMaths ne peut identifier l'objet '%s'\n", GetField(obj->Reponse, 1, 1));
			mTextout->TextInsert(text);
                	break;
                case TO_VARIABLE:
                	sprintf(text, "Variable '%s' cre!\n", GetField(obj->Reponse, 1, 1));
                	mTextout->TextInsert(text);
                	break;
                case TO_FONCTION:
                	sprintf(text, "Fonction '%s' cre!\n", GetField(obj->Reponse, 1, 1));
                	mTextout->TextInsert(text);
                	break;
                case TO_MATRICE:
                	sprintf(text, "Matrice '%s' cre!\n", GetField(obj->Reponse, 1, 1));
			mTextout->TextInsert(text);
                	break;
		case TO_INTERVALLE:
			sprintf(text, "Intervalle '%s' cr!\n", GetField(obj->Reponse, 1, 1));
			mTextout->TextInsert(text);
                	break;
		case TO_VECTEUR:
			sprintf(text, "Vecteur '%s' cr!\n", GetField(obj->Reponse, 1, 1));
			mTextout->TextInsert(text);
                	break;
		case TO_WHOLE:
			sprintf(text, "Ensemble '%s' cr!\n", GetField(obj->Reponse, 1, 1));
			mTextout->TextInsert(text);
                	break;
		case TO_PLOT:
			{/*
			
			VDKForm *chlid = MakeGraph(Application()->MainForm, obj);
			if (!child) return;
			GetMemory()->add(obj);
			child->Setup();
			child->ShowModal();
			sprintf(text, "Un objet Plot cre, que dois-je faire?\n");
			mTextout->TextInsert(text);
                	sprintf(text, "Je la mmorise\n");
			mTextout->TextInsert(text);*/
			}
                	break;
                case TO_PLOT2D:
                	sprintf(text, "Objet 2D  tracer\n");
			mTextout->TextInsert(text);
                	break;
                case TO_PLOT3D:
                	sprintf(text, "Objet 3D  tracer\n");
			mTextout->TextInsert(text);
                	break;
                default:
			printf("REP:%s  ID-->%s\n", obj->Reponse, GetField(obj->Reponse, 0, 0));
                	sprintf(text,"Sorry but I can't make anything %s\n",  GetField(obj->Reponse, 0, 0));
			mTextout->TextInsert(text);
                	break;
        }
}

bool EasymathsForm::LancerProgressbar(VDKObject *sender)
{
	ProgressForm *child = new ProgressForm(Application()->MainForm, "EasyMaths in fast progress ...");
	child->Setup();
	child->ShowModal();
	return TRUE;
}

void *EasymathsForm::LancerRun(void *sender)
{
	Run((VDKObject *)sender);
    	return NULL;
}

bool EasymathsForm::Run(VDKObject *sender)
{
	if (IsRunning)
	{
    		Application()->MessageBox("Attention", "Un traitement est dj en cours", MB_OK);
    		return TRUE;
    	}
    	IsRunning = TRUE;
    	mProgress = new ProgressForm(Application()->MainForm, "EasyMaths in fast progress ...");
    	mProgress->Setup();
    	SendToServer(mConnection, MakeQuery(new XMQuery, mConnection->mID, CQSCRIPT, mTextin->GetChars(0)));
   	mProgress->ShowModal();
   	delete mProgress;
   	mProgress = NULL;
    	IsRunning = FALSE;
    	return TRUE;
}

bool EasymathsForm::Quitter(VDKObject *sender)
{
    	if (Application()->MessageBox("Confirmation", "Voulez-vous vraiment quitter?", MB_YESNO) == IDYES)
    	{
    		ListenToServer(mConnection, 0, NULL);
        		sleep(1);
        		if (ShutdownServer(mConnection) != 2) sleep(3);        	
        		Close();
    	}
    	return TRUE;
}

XMObjectX *GetObjectX(char *name)
{
        return 0;
}
