 /***********************************************************************
 * =======================================				*
 * EasyMaths - IHM component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: VGlobal.h,v 1.3 2001/04/04 20:22:23 daville Exp $
 * $Log: VGlobal.h,v $
 * Revision 1.3  2001/04/04 20:22:23  daville
 * Ajout de lignes fin de fichier.
 *
 * Revision 1.2  2000/11/02 22:30:34  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef  V_GLOBAL_H
#define V_GLOBAL_H


static int PRECISION_GRAPH	= 3;
static int PRECISION_RESULTAT	= 15;

static char FONT_NAME_IN[]	= "Time new Roman";
static char FONT_NAME_OUT[]	= "Time new Roman";

/*
	 Configuration 2D

	RGB
*/

static char COLOR_FOND_2D[]	= {0, 0, 0};
static char COLOR_AXEX_2D[]	= {0, 255, 0};
static char COLOR_AXEY_2D[]	= {0, 255, 0};
static char COLOR_TRACER_2D[]	= {250, 50, 100};

static int GRILL_2D		= 0;
static int ECRAN_LARGEUR_2D	= 400;
static int ECRAN_HAUTEUR_2D	= 400;

static double STEP_2D		= 0.2;

/*
	 Configuration 3D

	RGB
*/

static char COLOR_FOND_3D[]	= {0, 0, 0};
static char COLOR_AXEX_3D[]	= {0, 255, 0};
static char COLOR_AXEY_3D[]	= {0, 255, 0};
static char COLOR_AXEZ_3D[]	= {0, 255, 0};
static char COLOR_TRACER_3D[]	= {250, 50, 100};

static int NAPPE		= 0;
static int ECRAN_LARGEUR_3D	= 500;
static int ECRAN_HAUTEUR_3D	= 500;

static int EYE_X_3D		= 200;
static int EYE_Y_3D		= 300;
static int EYE_Z_3D		= 250;
static int DISTANCE_3D		= 400;

static double THETA_3D		= 1.17;
static double PHI_3D		= -0.7;

static double STEP_THETA_3D	= 0.1;
static double STEP_PHI_3D	= 0.1;

static double STEP_3D		= 0.2;

/*
	Periode d'execution
*/


/*
	Taille de la mmoire
*/

static int MAX_MEMOIRE		= 100;
static int BIB_MAX_COLUMNS	= 3;

#define	EAS_MAX_FILELEN		200
#define	EAS_MAX_FILEOPEN	10

static char *EAS_TEXT_GENERATED[] =
	{
		"x = ",
		"I = a..b",
		"f(x) = ",
		"sum( )",
		"mat([ ])",
		"int( , x, a ... b)",
		"diff( , x)",
		"plot({CARTESIAN, }, x = a ...b)",
	0};

#endif	/* V_GLOBAL_H */

