#! /bin/sh
 ############################################################
 # =======================================			#
 # EasyMaths - Tools for EasyMaths				#
 # November 2000							#
 # =======================================			#
 #								#
 # Copyright (C) 2000, 2001 Didier Davill				#
 # Developed by Didier Davill <Didier.Daville@ddarea.com>		#
 #								#
 # This library is free software; you can redistribute it and/or modify 	#
 # it under the terms of the GNU Library General Public License as 	#
 # published by the Free Software Foundation; either version 2 of the	#
 # License, or (at your option) any later version.			#
 #								#
 # This library is distributed in the hope that it will be useful, but		#
 # WITHOUT ANY WARRANTY; without even the implied warranty of	#
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	#
 # See the GNU Library General Public License for more details.		#
 #								#
 # You should have received a copy of the GNU Library General Public	#
 # License along with this library; if not, write to the Free Software	#
 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		#
 # 02111-1307, USA.						#
 ############################################################

 ############################################################
 # $Author: daville $
 #
 # $Revision: 1.6 $
 #
 # $Id: Easymaths-admin.sh,v 1.6 2001/04/16 10:11:28 daville Exp $
 #
 #
 # $Log: Easymaths-admin.sh,v $
 # Revision 1.6  2001/04/16 10:11:28  daville
 # Renommade du fichier $HOME/.EasyMaths/.EasyMaths.conf$HOME/.EasyMaths/EasyMaths.confM_FIL
 #
 # Revision 1.5  2001/04/16 01:41:18  daville
 # Modification du test sur la variable EASYMATHS_FICHIER_CONFIG.
 #
 # Revision 1.4  2001/04/15 22:51:57  daville
 # Correctif pour l'ajout d'un nouveau utilisateur.
 #
 # Revision 1.3  2001/04/15 19:23:52  daville
 # Modification pour l'appel  l'outil de configuration de EasyMaths.
 #
 # Revision 1.2  2001/04/15 14:05:55  daville
 # Rcupration de la version pour la prsentation.
 #
 # Revision 1.1  2001/04/14 16:00:45  daville
 # Initial revision.
 #
 #
 #
 ############################################################


######################################
#	  Easymaths-admin.sh		#
#					#
######################################

PROG_SH_EASYMATHS_CONFIG=Easymaths-config.sh
VERSION=`echo "$Revision: 1.6 $"|cut -d" " -f2|sed s/" "//g`


function AfficherAide ( )
{
cat <<FIN

 ************************************************
  Easymaths-admin version $VERSION
  Copyright (C) 2000 EasyMaths of Didier Davill
  Easymaths-admin comes with ABSOLUTELY NO WARRANTY.
  This is free software, and you are welcome to
  redistribute it under certain conditions.
 *************************************************

Easymaths-admin [OPTION]
Avec [OPTION]
-h ? --help			affiche ce message
--adduser 			Configure a user home directory to use the GUI EasyMaths

FIN
}

function ChargerParametre ( )
{
	LIGNE=`grep $1= $EASYMATHS_FICHIER_CONFIG`
	PARAMETRE_CONFIG=`echo $LIGNE|cut -d= -f2`
}

function AjouterUtilisateur ( )
{
	Utilisateur=$1
	if [ -f ../EasyMaths/$PROG_SH_EASYMATHS_CONFIG  ]; then
		# On rcupre le rpertoire courant
		REP_EASYMATHS=`pwd`
		
		# Constitution du rpertoire de EasyMaths
		REP_EASYMATHS=`dirname $REP_EASYMATHS`/EasyMaths
		
		# Dplacement dans le rpertoire $HOME de l'utilisateur
		cd `cat /etc/passwd|grep ^$Utilisateur|cut -d: -f6`
		
		# Cration du rpertoire utilisateur de EasyMaths
		mkdir -p .EasyMaths
		
		# Copie du fichier de configuration pour l'IHM
		cp -f `$REP_EASYMATHS/$PROG_SH_EASYMATHS_CONFIG --home`/config/EasyMaths.conf .EasyMaths/EasyMaths.conf
		
		# Copie de la configuration du desktop KDE
		cp -f `dirname $REP_EASYMATHS`/config/EasyMaths.kdelnk Desktop/ 2>/dev/null
		
		# Attribution du bon utilisateur et groupe
		chown -R $Utilisateur:$Utilisateur .EasyMaths/
		
		if [ $? -eq 0 ]; then
			echo "EasyMaths a t configur pour l'utilisateur '$Utilisateur' avec succs"
		else
			echo "La configuration de EasyMaths pour l'utilisateur '$Utilisateur' a chou!!!!"
		fi
	else
		
		echo "Le programme de configuration [$PROG_SH_EASYMATHS_CONFIG], n'a pas t trouv!!!"
		echo "Impossible de configurer l'environnement de l'utilisateur '$Utilisateur'"
	fi
}

function ProcedurePrincipale ( )
{
	if [ $# = 0 ]; then
		AfficherAide
	fi
	if [ ! $EASYMATHS_FICHIER_CONFIG ]; then
		EASYMATHS_FICHIER_CONFIG=`pwd`
		export EASYMATHS_FICHIER_CONFIG=`dirname $EASYMATHS_FICHIER_CONFIG`/EasyMaths/Setup.conf
	fi
	case $1 in
		?| -h | --help) AfficherAide;;
		--adduser) AjouterUtilisateur $2;;
	esac
}

ProcedurePrincipale $*
